/*jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true */
/*global iw_form YAHOO IW_AC_DATA */

/*
 * Function to determine matches for the awesome bar
 *
 * @param string sQuery
 * @return array
 */
var awesomeMatch = function (sQuery) {
    sQuery = $.trim(decodeURI(sQuery.replace('%3A', ' '))).toLowerCase();

    let id          = 'iw-in-iw_awesome_input',
        data        = IW_AC_DATA[id],
        parts       = sQuery.split(' '),
        count_parts = parts.length,
        matches     = [],
        potential_match,
        i, j,
        count_data  = data.length;

    dataloop: for (i = 0; i < count_data; ++i) {
        potential_match = data[i];
        potential_match.d = $('<div/>').html(potential_match.d).text();

        for (j = 0; j < count_parts; ++j) {
            if (potential_match.d.toLowerCase().indexOf(parts[j]) === -1 &&
                potential_match.v.toLowerCase().indexOf(parts[j]) === -1) {
                continue dataloop;
            }
        }
        matches[matches.length] = {
            'value': potential_match.v,
            'label': potential_match.d
        };
    }

    return matches;
};

if ($('#iw-in-iw_awesome_input').length) {
    let input = $('#iw-in-iw_awesome_input'),
        AC = {};

    input.attr('tabindex', 1);
    //input.closest('div').css('z-index', 0);

    input.typeahead(
        {
            minLength: 1,
            highlight: true,
            hint     : true
        },
        {
            source : function (query, process) {
                let links = [];
                let map = {};

                let data = awesomeMatch(query);

                $.each(data, function (i, link) {
                    map[link.value] = $('<div/>').html(link.label).text();
                    links.push(link);
                });

                process(links);
            },
            display: function (suggestion) {
                return suggestion.label;
            },
            limit  : 10,
            templates : {
                suggestion: function (suggestion) {
                    let target = '';
                    if (suggestion.value.includes('siteworxLoginCommit')) {
                        target = 'target="_blank" rel="noopener noreferrer"';
                    }
                    return (`
                        <a class="d-block" href="${suggestion.value}" ${target}>
                        ${suggestion.label}
                        </a>
                    `);
                }
            }
            // display: 'label'
        }
    );

    if (!input.attr('placeholder')) {
        input.attr('placeholder', '##LG_SEARCH##...');
    }

    // If a user hits enter without a selection, highlight the first option, if they hit enter again, go to that option
    $(document).on('keypress', '#iw-in-iw_awesome_input', function (e) {
        if (e.which == 13) {
            if (ttMenuIsOpen()) {
                highlightFirstOption(e);
            } else {
                goToFirstSuggestion(e)
            }
        }
    })

    let ttMenuIsOpen = function () {
        return $("div.tt-open").length !== 0;
    }

    let highlightFirstOption = function (e) {
        var first_option = $("a.tt-suggestion").first();
        first_option.addClass("tt-cursor");
        e.preventDefault();
    }

    // If a user clicks "Search" without a selection, just pick the first in the list
    $(document).on('click', 'button.iw-awesome-search', function (e) {
        goToFirstSuggestion(e);
    })

    let goToFirstSuggestion = function (e) {
        input.blur();
        input.focus();
        input.blur();
        let first_option = $("a.tt-suggestion").first().prop('href');
        if (first_option !== undefined) {
            window.location = first_option;
        }
        e.preventDefault();
    }

    input.focus(iw_form.onACFocus);

    AC.applyLocalFilter = true;
    AC.queryMatchContains = true;

    iw_form.registeredACs[input.attr('id')] = AC;

    // Handle Ctrl+Space trigger
    let down = [];
    $(document).keydown(function (e) {
        down[e.keyCode] = true;
    }).keyup(function (e) {
        if (down[17] && down[32]) {
            input.focus();
        }
        down[e.keyCode] = false;
    });
}//end if
